"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsDayjs = exports.IS_DAYJS = void 0;
const class_validator_1 = require("class-validator");
const is_dayjs_options_1 = require("./is-dayjs.options");
const is_dayjs_predicate_1 = require("./is-dayjs.predicate");
exports.IS_DAYJS = 'isDayjs';
function IsDayjs(validationOptions = {}) {
    const decoratorOptions = is_dayjs_options_1.optionsWithDefaults(validationOptions);
    return class_validator_1.ValidateBy({
        name: exports.IS_DAYJS,
        validator: {
            validate: (value, _arguments) => is_dayjs_predicate_1.isDayjs(value, decoratorOptions),
            defaultMessage: class_validator_1.buildMessage(eachPrefix => `${eachPrefix}$property must be ${decoratorOptions.is_valid ? 'a valid' : 'a'} Dayjs instance`, validationOptions),
        },
    }, validationOptions);
}
exports.IsDayjs = IsDayjs;
//# sourceMappingURL=is-dayjs.decorator.js.map