"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsMonotonic = exports.IS_MONOTONIC = void 0;
const class_validator_1 = require("class-validator");
const is_monotonic_predicate_1 = require("./is-monotonic.predicate");
exports.IS_MONOTONIC = 'isMonotonic';
function IsMonotonic(validationOptions) {
    return class_validator_1.ValidateBy({
        name: exports.IS_MONOTONIC,
        validator: {
            validate: (value, _arguments) => is_monotonic_predicate_1.isMonotonic(value, validationOptions.selector, validationOptions.monotonicity),
            defaultMessage: class_validator_1.buildMessage(eachPrefix => `${eachPrefix}$property must be a ${validationOptions.monotonicity} array`, validationOptions),
        },
    }, validationOptions);
}
exports.IsMonotonic = IsMonotonic;
//# sourceMappingURL=is-monotonic.decorator.js.map